/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates an option menu.
***************************************************************/

/* option_menu.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel;
Widget option_menu;
Widget option1_item;
Widget option2_item;
Widget option3_item;

void menuCB(w,client_data,call_data)
    Widget w;
    char *client_data;
    XmAnyCallbackStruct *call_data;
/* callback routine used for all menus */
{
    printf("%s\n",client_data);
}

Widget make_menu_item(item_name,client_data,menu)
    char *item_name;
    XtPointer client_data;
    Widget menu;
/* adds an item into a menu. */ 
{
    int ac;
    Arg al[10];
    Widget item;

    ac = 0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreateLtoR(item_name,char_set)); ac++;  
    item=XmCreatePushButton(menu,item_name,al,ac);
    XtManageChild(item);
    XtAddCallback(item,XmNactivateCallback,menuCB,client_data);  
    XtSetSensitive(item,True);
    return(item);
}

void main(argc,argv)
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;
    Widget menu;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    menu=XmCreatePulldownMenu(toplevel,"menu",NULL,0);
    ac=0;
    XtSetArg (al[ac],XmNsubMenuId, menu); ac++;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreateLtoR("Sample",char_set)); ac++;
    option_menu=XmCreateOptionMenu(toplevel,"option_menu",al,ac);  
    XtManageChild(option_menu);
    option1_item=make_menu_item("Option1","Option1 selected",menu);
    option2_item=make_menu_item("Option2","Option2 selected",menu);
    option3_item=make_menu_item("Option3","Option3 selected",menu);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
